﻿#ifndef CPLAYER_H
#define CPLAYER_H

#include "../common/sources/system/cmaths.h"
#include "../common/sources/Map.h"

class CPlayer
{
public:
    CPlayer();

    CVec2       getPosFromLocal(CVec2 localPos);
    EWallSide   getWallSide(EWallSide side);
    CVec2       getLocalFromPos(CVec2 mapPos);

    void        turnLeft();
    void        turnRight();
    void        moveLeft();
    void        moveRight();
    void        moveForward();
    void        moveBackward();

    void        takeStairs();
    void        teleport();

    CVec2   pos;    // position dans la map
    uint8_t dir;    // direction: 0=haut, 1=gauche, 2=bas, 3=droite
    bool    shouldTakeStairs;
    bool    shouldTeleport;

private:
    void moveIfPossible(EWallSide side);
};

extern CPlayer  player;

#endif // CPLAYER_H
